当前位置:   article > 正文

LeetCode 1. 两数之和

LeetCode 1. 两数之和

题目:

LeetCode 1. 两数之和
难度:easy

给定一个整数数组 nums 和一个整数目标值 target,请你在该数组中找出 和为目标值 target 的那 两个 整数,并返回它们的数组下标。
你可以假设每种输入只会对应一个答案。但是,数组中同一个元素在答案里不能重复出现。
你可以按任意顺序返回答案。

示例 1:

输入:nums = [2,7,11,15], target = 9
输出:[0,1]
解释:因为 nums[0] + nums[1] == 9 ,返回 [0, 1] 。
  • 1
  • 2
  • 3

示例 2:

输入:nums = [3,2,4], target = 6
输出:[1,2]
  • 1
  • 2

示例 3:

输入:nums = [3,3], target = 6
输出:[0,1]
  • 1
  • 2

提示:

2 <= nums.length <= 104
-109 <= nums[i] <= 109
-109 <= target <= 109
只会存在一个有效答案。
  • 1
  • 2
  • 3
  • 4

解题方法:

方法1:(暴力破解法)

Java实现
class Solution {
    public int[] twoSum(int[] nums, int target) {
        int length = nums.length;
        for (int i = 0; i < length; i++) {
            for (int j = i + 1; j < length; j++) {
                if (nums[i] + nums[j] == target) {
                    return new int[]{i, j};
                }
            }
        }
        return new int[0];
    }
}
  • 1
  • 2
  • 3
  • 4
  • 5
  • 6
  • 7
  • 8
  • 9
  • 10
  • 11
  • 12
  • 13

复杂度分析
时间复杂度:O(N^2),其中 N 为数组长度的长度。
空间复杂度:O(1),不需要额外申请空间。

方法2:(哈希法)

Java实现
class Solution {
    public int[] twoSum(int[] nums, int target) {
        Map<Integer, Integer> map = new HashMap(16);
        for (int i = 0; i < nums.length; i++) {
            if (map.get(target - nums[i]) != null) {
                return new int[]{map.get(target - nums[i]), i};
            }
            map.put(nums[i], i);
        }
        return new int[0];
    }
}
  • 1
  • 2
  • 3
  • 4
  • 5
  • 6
  • 7
  • 8
  • 9
  • 10
  • 11
  • 12

复杂度分析
时间复杂度:O(N),其中 N 为数组的长度。
空间复杂度:O(N),其中 N 是数组中的元素数量。主要是哈希表的开销。

声明:本文内容由网友自发贡献,不代表【wpsshop博客】立场,版权归原作者所有,本站不承担相应法律责任。如您发现有侵权的内容,请联系我们。转载请注明出处:https://www.wpsshop.cn/w/繁依Fanyi0/article/detail/299691
推荐阅读
相关标签
  

闽ICP备14008679号